searchNodes=[{"doc":"Allows to create a plug enforcing authentication for private routes.A user-defined module must use this module, making the user module a plug, and implement the handle_authentication_error/2 behaviour. The handle_authentication_error/2 callback receives a Plug.Conn struct and an atom identifying the set of routes that require authentication, and must return a Plug.Conn struct.Example: defmodule MyAppWeb.Plugs.EnsureAuthenticated do use AuthN.AuthenticationPlugMixin import Plug.Conn import Phoenix.Controller def handle_authentication_error(conn, :admin_routes), do: conn |&gt; put_status(401) |&gt; text(&quot;unauthenticated&quot;) |&gt; halt() end EnsureAuthenticated is now a plug which can be used in the router: pipeline :ensure_admin_routes_authorized do plug MyAppWeb.Plugs.EnsureAuthenticated, resource: :admin_routes end scope &quot;/admin&quot;, MyAppWeb, as: :admin do pipe_through [:browser, :ensure_admin_routes_authorized] # code end","ref":"AuthN.AuthenticationPlugMixin.html","title":"AuthN.AuthenticationPlugMixin","type":"behaviour"},{"doc":"","ref":"AuthN.AuthenticationPlugMixin.html#c:handle_authentication_error/2","title":"AuthN.AuthenticationPlugMixin.handle_authentication_error/2","type":"callback"},{"doc":"","ref":"AuthN.HTML.AuthNHelpers.html","title":"AuthN.HTML.AuthNHelpers","type":"module"},{"doc":"View helper allowing to check whether the current user is authenticated or not.","ref":"AuthN.HTML.AuthNHelpers.html#authenticated?/1","title":"AuthN.HTML.AuthNHelpers.authenticated?/1","type":"function"},{"doc":"View helper returning the current user or nil in case the current user is not authenticated.","ref":"AuthN.HTML.AuthNHelpers.html#current_user/1","title":"AuthN.HTML.AuthNHelpers.current_user/1","type":"function"},{"doc":"This plug fetches the current user by the user token stored in session and stores the user in conn.assigns.The user is fetched by a function provided through the mandatory :get_user_by_session_token_fun option; the function receives the user ID as argument.In case no user token is stored in session, this plug does nothing (just returns the conn received). In case a user token is stored in session, but no user can be found for that token, the plug clears the session.","ref":"AuthN.Plugs.AssignCurrentUser.html","title":"AuthN.Plugs.AssignCurrentUser","type":"module"},{"doc":"","ref":"AuthN.Plugs.AssignCurrentUser.html#call/2","title":"AuthN.Plugs.AssignCurrentUser.call/2","type":"function"},{"doc":"","ref":"AuthN.Plugs.AssignCurrentUser.html#init/1","title":"AuthN.Plugs.AssignCurrentUser.init/1","type":"function"},{"doc":"","ref":"AuthN.Plugs.RedirectIfUserIsAuthenticated.html","title":"AuthN.Plugs.RedirectIfUserIsAuthenticated","type":"module"},{"doc":"","ref":"AuthN.Plugs.RedirectIfUserIsAuthenticated.html#call/2","title":"AuthN.Plugs.RedirectIfUserIsAuthenticated.call/2","type":"function"},{"doc":"","ref":"AuthN.Plugs.RedirectIfUserIsAuthenticated.html#init/1","title":"AuthN.Plugs.RedirectIfUserIsAuthenticated.init/1","type":"function"},{"doc":"This plug allows to change the storage mechanism for sessions.By default, the session is stored into a stateless cookie.","ref":"AuthN.Plugs.SetSessionStorage.html","title":"AuthN.Plugs.SetSessionStorage","type":"module"},{"doc":"","ref":"AuthN.Plugs.SetSessionStorage.html#call/2","title":"AuthN.Plugs.SetSessionStorage.call/2","type":"function"},{"doc":"","ref":"AuthN.Plugs.SetSessionStorage.html#init/1","title":"AuthN.Plugs.SetSessionStorage.init/1","type":"function"},{"doc":"Module used for storing, retrieving and deleting the user token into/from the session.This module serves as an interface, delegating calls to another module implementing the session's storage logic. The default implementation module is AuthN.SessionStorage.StatelessCookie, which stores sessions into stateless cookies. Another module implementing sessions storage can be specified by adding the module name into the :session_storage key of conn.private.","ref":"AuthN.SessionStorage.html","title":"AuthN.SessionStorage","type":"behaviour"},{"doc":"","ref":"AuthN.SessionStorage.html#delete_user_token/2","title":"AuthN.SessionStorage.delete_user_token/2","type":"function"},{"doc":"","ref":"AuthN.SessionStorage.html#c:delete_user_token/2","title":"AuthN.SessionStorage.delete_user_token/2","type":"callback"},{"doc":"","ref":"AuthN.SessionStorage.html#get_user_token/1","title":"AuthN.SessionStorage.get_user_token/1","type":"function"},{"doc":"","ref":"AuthN.SessionStorage.html#c:get_user_token/1","title":"AuthN.SessionStorage.get_user_token/1","type":"callback"},{"doc":"","ref":"AuthN.SessionStorage.html#put_user_token/2","title":"AuthN.SessionStorage.put_user_token/2","type":"function"},{"doc":"","ref":"AuthN.SessionStorage.html#c:put_user_token/2","title":"AuthN.SessionStorage.put_user_token/2","type":"callback"},{"doc":"","ref":"AuthN.SessionStorage.html#t:conn/0","title":"AuthN.SessionStorage.conn/0","type":"type"},{"doc":"Module for storing sessions into conn.private. Used for testing.","ref":"AuthN.SessionStorage.AssignsMap.html","title":"AuthN.SessionStorage.AssignsMap","type":"module"},{"doc":"Callback implementation for AuthN.SessionStorage.delete_user_token/2.","ref":"AuthN.SessionStorage.AssignsMap.html#delete_user_token/2","title":"AuthN.SessionStorage.AssignsMap.delete_user_token/2","type":"function"},{"doc":"Callback implementation for AuthN.SessionStorage.get_user_token/1.","ref":"AuthN.SessionStorage.AssignsMap.html#get_user_token/1","title":"AuthN.SessionStorage.AssignsMap.get_user_token/1","type":"function"},{"doc":"Callback implementation for AuthN.SessionStorage.put_user_token/2.","ref":"AuthN.SessionStorage.AssignsMap.html#put_user_token/2","title":"AuthN.SessionStorage.AssignsMap.put_user_token/2","type":"function"},{"doc":"","ref":"AuthN.SessionStorage.AssignsMap.html#t:conn/0","title":"AuthN.SessionStorage.AssignsMap.conn/0","type":"type"},{"doc":"Module for storing sessions into stateless cookies.This is the library's default storage mechanism for storing sessions.","ref":"AuthN.SessionStorage.StatelessCookie.html","title":"AuthN.SessionStorage.StatelessCookie","type":"module"},{"doc":"Callback implementation for AuthN.SessionStorage.delete_user_token/2.","ref":"AuthN.SessionStorage.StatelessCookie.html#delete_user_token/2","title":"AuthN.SessionStorage.StatelessCookie.delete_user_token/2","type":"function"},{"doc":"Callback implementation for AuthN.SessionStorage.get_user_token/1.","ref":"AuthN.SessionStorage.StatelessCookie.html#get_user_token/1","title":"AuthN.SessionStorage.StatelessCookie.get_user_token/1","type":"function"},{"doc":"","ref":"AuthN.SessionStorage.StatelessCookie.html#put_user_token/3","title":"AuthN.SessionStorage.StatelessCookie.put_user_token/3","type":"function"},{"doc":"","ref":"AuthN.SessionStorage.StatelessCookie.html#t:conn/0","title":"AuthN.SessionStorage.StatelessCookie.conn/0","type":"type"},{"doc":"AuthN","ref":"readme.html","title":"AuthN","type":"extras"},{"doc":"Add auth_n for Elixir as a dependency in your mix.exs file:def deps do [ {:auth_n, &quot;~&gt; 0.21.0&quot;} ] end","ref":"readme.html#installation","title":"AuthN - Installation","type":"extras"},{"doc":"HexDocs documentation can be found at https://hexdocs.pm/auth_n.","ref":"readme.html#hexdocs","title":"AuthN - HexDocs","type":"extras"}]